/**
 * GLISTTS.java
 *
 * File generated from the datatypes::GLISTTS uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ips.datatypes;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class GLISTTS.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "GLIST_TS", propOrder = {
	"head",
	"increment",
	"denominator",
	"period"
})
@XmlRootElement(name = "GLIST_TS")
public class GLISTTS extends net.ihe.gazelle.ips.datatypes.ANY implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *  This is the start-value of the generated list. .
	 */
	@XmlElement(name = "head", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.ips.datatypes.TS head;
	/**
	 *  The difference between one value and its previous different value. For example, to generate the sequence (1; 4; 7; 10; 13; ...) the increment is 3; likewise to generate the sequence (1; 1; 4; 4; 7; 7; 10; 10; 13; 13; ...) the increment is also 3. .
	 */
	@XmlElement(name = "increment", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.ips.datatypes.PQ increment;
	/**
	 *  The integer by which the index for the sequence is divided, effectively the number of times the sequence generates the same sequence item value before incrementing to the next sequence item value. For example, to generate the sequence (1; 1; 1; 2; 2; 2; 3; 3; 3; ...) the denominator is 3. .
	 */
	@XmlAttribute(name = "denominator")
	@javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter(net.ihe.gazelle.adapters.IntegerAdapter.class)
	public Integer denominator;
	/**
	 *  If non-NULL, specifies that the sequence alternates, i.e., after this many increments, the sequence item values roll over to start from the initial sequence item value. For example, the sequence (1; 2; 3; 1; 2; 3; 1; 2; 3; ...) has period 3; also the sequence (1; 1; 2; 2; 3; 3; 1; 1; 2; 2; 3; 3; ...) has period 3 too. .
	 */
	@XmlAttribute(name = "period")
	@javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter(net.ihe.gazelle.adapters.IntegerAdapter.class)
	public Integer period;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return head.
	 * @return head :  This is the start-value of the generated list. 
	 */
	public net.ihe.gazelle.ips.datatypes.TS getHead() {
	    return head;
	}
	
	/**
	 * Set a value to attribute head.
	 * @param head :  This is the start-value of the generated list. .
	 */
	public void setHead(net.ihe.gazelle.ips.datatypes.TS head) {
	    this.head = head;
	}
	
	
	
	
	/**
	 * Return increment.
	 * @return increment :  The difference between one value and its previous different value. For example, to generate the sequence (1; 4; 7; 10; 13; ...) the increment is 3; likewise to generate the sequence (1; 1; 4; 4; 7; 7; 10; 10; 13; 13; ...) the increment is also 3. 
	 */
	public net.ihe.gazelle.ips.datatypes.PQ getIncrement() {
	    return increment;
	}
	
	/**
	 * Set a value to attribute increment.
	 * @param increment :  The difference between one value and its previous different value. For example, to generate the sequence (1; 4; 7; 10; 13; ...) the increment is 3; likewise to generate the sequence (1; 1; 4; 4; 7; 7; 10; 10; 13; 13; ...) the increment is also 3. .
	 */
	public void setIncrement(net.ihe.gazelle.ips.datatypes.PQ increment) {
	    this.increment = increment;
	}
	
	
	
	
	/**
	 * Return denominator.
	 * @return denominator :  The integer by which the index for the sequence is divided, effectively the number of times the sequence generates the same sequence item value before incrementing to the next sequence item value. For example, to generate the sequence (1; 1; 1; 2; 2; 2; 3; 3; 3; ...) the denominator is 3. 
	 */
	public Integer getDenominator() {
	    return denominator;
	}
	
	/**
	 * Set a value to attribute denominator.
	 * @param denominator :  The integer by which the index for the sequence is divided, effectively the number of times the sequence generates the same sequence item value before incrementing to the next sequence item value. For example, to generate the sequence (1; 1; 1; 2; 2; 2; 3; 3; 3; ...) the denominator is 3. .
	 */
	public void setDenominator(Integer denominator) {
	    this.denominator = denominator;
	}
	
	
	
	
	/**
	 * Return period.
	 * @return period :  If non-NULL, specifies that the sequence alternates, i.e., after this many increments, the sequence item values roll over to start from the initial sequence item value. For example, the sequence (1; 2; 3; 1; 2; 3; 1; 2; 3; ...) has period 3; also the sequence (1; 1; 2; 2; 3; 3; 1; 1; 2; 2; 3; 3; ...) has period 3 too. 
	 */
	public Integer getPeriod() {
	    return period;
	}
	
	/**
	 * Set a value to attribute period.
	 * @param period :  If non-NULL, specifies that the sequence alternates, i.e., after this many increments, the sequence item values roll over to start from the initial sequence item value. For example, the sequence (1; 2; 3; 1; 2; 3; 1; 2; 3; ...) has period 3; also the sequence (1; 1; 2; 2; 3; 3; 1; 1; 2; 2; 3; 3; ...) has period 3 too. .
	 */
	public void setPeriod(Integer period) {
	    this.period = period;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.ips.datatypes");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "GLIST_TS").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(GLISTTS gLISTTS, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (gLISTTS != null){
   			net.ihe.gazelle.ips.datatypes.ANY.validateByModule(gLISTTS, _location, cvm, diagnostic);
			net.ihe.gazelle.ips.datatypes.TS.validateByModule(gLISTTS.getHead(), _location + "/head", cvm, diagnostic);
			net.ihe.gazelle.ips.datatypes.PQ.validateByModule(gLISTTS.getIncrement(), _location + "/increment", cvm, diagnostic);
    	}
    }

}